.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_READLINK.9,v 1.1.2.3 1999/09/05 11:27:13 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VOP_READLINK 9
.Sh NAME
.Nm VOP_READLINK
.Nd read the target of a symbolic link
.Sh SYNOPSIS
.Fd #include <sys/vnode.h>
.Fd #include <sys/uio.h>
.Ft int
.Fn VOP_READLINK "struct vnode *vp" "struct uio *uio" "struct ucred *cred"
.Sh DESCRIPTION
This reads the target pathname of a symbolic link
.Bl -tag -width uio
.It Ar vp
the vnode of the symlink
.It Ar uio
the location of the data to be read or written
.It Ar cnp
the credentials of the caller
.El
.Sh LOCKS
The vnode should be locked on entry and will still be locked on exit.
.Sh RETURN VALUES
Zero is returned on success, otherwise an error code is returned.
.Sh PSEUDOCODE
.Bd -literal
int
vop_readlink(struct vnode *vp, struct uio *uio, struct ucred *cred)
{
    int error = 0;

    /*
     * Read the target of the symlink.
     */
    ...;

    return error;
}
.Ed
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er EIO
a read error occurred while reading the contents of the symlink
.El
.Sh SEE ALSO
.Xr vnode 9 ,
.Xr uiomove 9
.Sh AUTHORS
This man page was written by Doug Rabson.
